// http://wordpress.org/extend/plugins/ajax-comment-posting/
// http://wordpress.org/support/topic/plugin-ajax-comment-posting-duplicate-script-loading-bug-fix?replies=1
jQuery(document).ready(function() {
	/* acp_lang[]:
	   [0]: 'Loading...'
	   [1]: 'Please enter your name.'
	   [2]: 'Please enter your email address.'
	   [3]: 'Please enter a valid email address.'
	   [4]: 'Please enter your comment'
	   [5]: 'Your comment has been added.'
	   [6]: 'ACP error!'
	*/

	// initialise
	jQuery.ajaxSetup ({  
		cache: false  
	}); 
	var form, err, reply;
	function acp_initialise() {
		jQuery('#submit-container').after('<div id="error"></div>');
		//jQuery('#commentform').after('<div id="ccaptcha"></div>');
		jQuery('#submit').before('<img width="16" height="16" src="'+spinner+'" id="comment-loading" alt="'+acp_lang[0]+'" />');
		jQuery('#comment-loading').hide();
		form = jQuery('#commentform');
		err = jQuery('#error');
		reply = false;
	}
	acp_initialise();

	jQuery('.comment-reply-link').live('click', function() {
		// checks if it's a reply to a comment
	        reply = jQuery(this).parents('.depth-1').attr('id');
		err.empty();
	    });

	jQuery('#cancel-comment-reply-link').live('click', function() {
		reply = false;
	    });	
	
        jQuery('#commentform').live('submit', function(evt) {

		err.empty();
    
/*
		if(form.find('#author')[0]) {
		    // if not logged in, validate name and email
		    if(form.find('#author').val() == '') {
			err.html('<span class="error">'+acp_lang[1]+'</span>');
			return false;
		    }
		    if(form.find('#email').val() == '') {
			err.html('<span class="error">'+acp_lang[2]+'</span>');
			return false;
		    }
		    var filter  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		    if(!filter.test(form.find('#email').val())) {
			err.html('<span class="error">'+acp_lang[3]+'</span>');
			if (evt.preventDefault) {evt.preventDefault();}
			return false;
		    }
		} // end if
*/
		if(form.find('#comment').val() == '') {
			err.html('<span class="error">'+acp_lang[4]+'</span>');
			return false;
		}

		jQuery(this).ajaxSubmit({
			
			beforeSubmit: function() {
				jQuery('#comment-loading').show();
				jQuery('#submit').attr('disabled','disabled');
			}, // end beforeSubmit
		    
			error: function(request){
				if (jQuery('#is_404').length > 0) {
					if (jQuery('#is_404').attr('value') == 'true') {
//TODO: got a genuine error commenting a 404? tough...
						return this.success(request.responseText);
					}
				}
				err.empty();
				var data = request.responseText.match(/<p>(.*)<\/p>/);
				err.html('<span class="error">'+ data[1] +'</span>');
				jQuery('#comment-loading').hide();
				jQuery('#submit').removeAttr("disabled");
				return false;
			}, // end error()
		    
			success: function(data) {
				try {
					var id = form.parents('div').find('article').attr('id');
					var lastDash = id.lastIndexOf('-');
					var postId = id.substring(lastDash+1);
					var commentsBegin = '<!-- BEGIN comments-'+postId+' -->';
					var commentsEnd = '<!-- END comments-'+postId+' -->';
					var response = data.split(commentsBegin);
					response = response[1].split(commentsEnd);
					response = response[0];
					var nOfComments = form.parents('div').find('.n-of-comments');
					nOfComments.html(  parseInt( nOfComments.html() ) + 1  );

					var comments = form.parents('.response').find('.comments');
					var lastComment = comments.find('li.comment:last');
					var lastCommentId = lastComment.attr('id');

					var newComments = jQuery('<div>').html((String(response)));
					var newComment = newComments.find('li.comment:last');
					var newCommentId = newComment.attr('id');
					if (lastCommentId == newCommentId) {
					// akismet ate my comment!
						throw(acp_lang[6]);
					}
					else {
						var placeHolder = comments.find('.comment-placeholder');
						placeHolder.before('<li class="comment byuser" id="'+newCommentId+'">'+newComment.html()+'</li>');

						// update number of comments on page.
						if ( jQuery('.comment-count').length > 0 ) {
							var oldCommentCount = jQuery('.comment-count').html();
							if (Math.floor(oldCommentCount) == oldCommentCount) {
								var newCommentCount = Math.floor(oldCommentCount)+1;
								jQuery('.comment-count').html(  String( Math.floor(newCommentCount) )  );

								var short = comments_multiple_short_i18n; 
								var long = comments_multiple_long_i18n;
								if ( newCommentCount == 1 ) {
									short = comments_single_short_i18n;
									long = comments_single_long_i18n;
								}

								jQuery('.comments-meta-postfix').each(function() {
									jQuery(this).html(short);
								});
								jQuery('.comments-title-postfix').each(function() {
									jQuery(this).html(long);
								});
							}
						}

						var newLastComment = jQuery('#'+newCommentId);
						form.find('#comment').val('');
						err.empty();
						jQuery('#submit').removeAttr("disabled");
						jQuery('#comment-loading').hide();
						jQuery("#commenting-fieldset-collapsible").collapse(250, function() {
							if(typeof permalinkSlider == 'function') {
								var lastScroller = newLastComment.find('a.comment-permalink-scroller');
								lastScroller.click(permalinkSlider);
								lastScroller.trigger('click');
							}
						});

					}


				} catch (e) {
					var error = e;
					if (e != acp_lang[6]) {
						error = acp_lang[7] + ': ' + e.message;
					}
					jQuery('#comment-loading').hide();
					jQuery('#submit').removeAttr("disabled");
					err.html('<span class="error">'+ error +'</span>');
				} // end try
					   
			} // end success()

		}); // end ajaxSubmit()
		
		return false; 
		
	    }); // end form.submit()

});

